#include "asm86.h"
#include "ti86asm.inc"

userInt       = 2
userflags     = $23
_user_int_chk = $d2fd
_user_int_ram = $d2fe

.org			_asm_exec_ram
	bit		userInt,(iy+userflags)		;Is an interrupt enabled?
	jr		z,InstallIt				;If not, install one.
	res		userInt,(iy+userflags)		;Turn it off.
	ret

InstallIt:
	ld		hl,CodeStart				;Start of new interrupt.
	ld		de,_user_int_ram			;Interrupt storage area.
	ld		bc,IntEnd-IntStart			;Run-Time-dynamic interrupt length.
	ldir
	ld		a,(_user_int_ram)			;Make a checksum...
	ld		hl,_user_int_ram+$27
	add		a,(hl)
	ld		hl,_user_int_ram+$4F
	add		a,(hl)
	ld		hl,_user_int_ram+$77
	add		a,(hl)
	ld		hl,_user_int_ram+$9F
	add		a,(hl)
	ld		hl,_user_int_ram+$C7
	add		a,(hl)
	ld		(_user_int_chk),a
	set		userInt,(iy+userflags)		;Turn on new interrupt...
	ret

CodeStart:							;Marker for start of interrupt code.
.org			_user_int_ram				;Makes JPs and CALLs work.

IntStart:								;For length math.
	push af							;We use af.
	push hl							;We use hl.
	ld		hl,(ToggleByte)			;Get the last byte flipped.
	inc		hl						;Get new byte to flip.
	xor		a						;Zero out a.
	cp		h						;If h=0, time to restart!
	jr		nz,NoReset
	ld		hl,$FC00					;Start at Video Memory.
NoReset:
	ld		a,$FF					;Prepare to flip all 8 bits.
	xor		(hl)						;Flip!
	ld		(hl),a					;Store flipped byte
	ld		(ToggleByte),hl			;Store flipped byte's number.
	pop hl
	pop af
	ret
ToggleByte:
 .dw $FBFF							;It INCs before it flips...
IntEnd:
.end
